diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
index ce7182b92..9bdc88504 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRenderer.java
@@ -7,23 +7,170 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
-public interface FontRenderer extends Font {
-    void render(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderCentered(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderCenteredDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderWidthConstrained(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderWidthConstrainedDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderConstrained(@NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, int maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-    void renderConstrainedDouble(@NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, double maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
-
-    @NotNull List<String> splitCharsIntoLines(@NotNull CharSequence chars, double maxWidth, @Nullable List<String> output);
-    @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull List<String> lines, double maxWidth, @Nullable List<String> output);
-    double heightOfConstrainedChars(@NotNull CharSequence chars, double maxWidth);
-    double heightOfLines(@NotNull List<String> lines, double maxWidth);
-
-    double stringWidthDouble(CharSequence chars);
-    default int stringWidth(final CharSequence chars) {
-        return MathHelper.ceil(stringWidthDouble(chars));
+@SuppressWarnings("unused")
+public abstract class FontRenderer {
+    protected static final long CONFIG_DEFAULT = 0xFF_FF_FF_FFL;
+    protected static final @NotNull String NULL_STRING = String.valueOf((Object) null);
+
+    private static final RenderIntegerBase method_render = new RenderIntegerBase() { @Override public void call() {
+        this.fontRenderer.renderImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderDoubleBase method_renderDouble = new RenderDoubleBase() { @Override public void call() {
+        this.fontRenderer.renderDoubleImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderIntegerBase method_renderCentered = new RenderIntegerBase() { @Override public void call() {
+        this.fontRenderer.renderCenteredImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderDoubleBase method_renderCenteredDouble = new RenderDoubleBase() { @Override public void call() {
+        this.fontRenderer.renderCenteredDoubleImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderIntegerConstrainedBase method_renderWidthConstrained = new RenderIntegerConstrainedBase() { @Override public void call() {
+        this.fontRenderer.renderWidthConstrainedImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderDoubleConstrainedBase method_renderWidthConstrainedDouble = new RenderDoubleConstrainedBase() { @Override public void call() {
+        this.fontRenderer.renderWidthConstrainedDoubleImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderIntegerConstrainedBase method_renderConstrained = new RenderIntegerConstrainedBase() { @Override public void call() {
+        this.fontRenderer.renderConstrainedImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.maxHeight, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private static final RenderDoubleConstrainedBase method_renderConstrainedDouble = new RenderDoubleConstrainedBase() { @Override public void call() {
+        this.fontRenderer.renderConstrainedDoubleImpl(this.font, this.tessellator, this.chars, this.x, this.y, this.z, this.shadow, this.config, this.maxWidth, this.maxHeight, this.alignment, this.xPosBuffer, this.yPosBuffer, this.configBuffer); this.needCall = false; }};
+
+    private final double @NotNull [] xPosBuffer = new double[1];
+    private final double @NotNull [] yPosBuffer = new double[1];
+    private final long @NotNull [] configBuffer = new long[1];
+
+    abstract void renderImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, @Nullable final Object o, final int x, final int y) { return render(tessellator, String.valueOf(o), x, y); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final boolean b, final int x, final int y) { return method_render.init(this, tessellator, Boolean.toString(b), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final int i, final int x, final int y) { return method_render.init(this, tessellator, Integer.toString(i), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final long l, final int x, final int y) { return method_render.init(this, tessellator, Long.toString(l), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final char c, final int x, final int y) { return method_render.init(this, tessellator, String.valueOf(c), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final float f, final int x, final int y) { return method_render.init(this, tessellator, Float.toString(f), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final double d, final int x, final int y) { return method_render.init(this, tessellator, Double.toString(d), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final int x, final int y) { return method_render.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase render(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final int x, final int y) {return method_render.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderDoubleImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, @Nullable final Object o, final double x, final double y) { return renderDouble(tessellator, String.valueOf(o), x, y); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final boolean b, final double x, final double y) { return method_renderDouble.init(this, tessellator, Boolean.toString(b), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final int i, final double x, final double y) { return method_renderDouble.init(this, tessellator, Integer.toString(i), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final long l, final double x, final double y) { return method_renderDouble.init(this, tessellator, Long.toString(l), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final char c, final double x, final double y) { return method_renderDouble.init(this, tessellator, String.valueOf(c), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final float f, final double x, final double y) { return method_renderDouble.init(this, tessellator, Float.toString(f), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final double d, final double x, final double y) { return method_renderDouble.init(this, tessellator, Double.toString(d), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final double x, final double y) { return method_renderDouble.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderDouble(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final double x, final double y) {return method_renderDouble.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderCenteredImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, @Nullable final Object o, final int x, final int y) { return renderCentered(tessellator, String.valueOf(o), x, y); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final boolean b, final int x, final int y) { return method_renderCentered.init(this, tessellator, Boolean.toString(b), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final int i, final int x, final int y) { return method_renderCentered.init(this, tessellator, Integer.toString(i), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final long l, final int x, final int y) { return method_renderCentered.init(this, tessellator, Long.toString(l), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final char c, final int x, final int y) { return method_renderCentered.init(this, tessellator, String.valueOf(c), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final float f, final int x, final int y) { return method_renderCentered.init(this, tessellator, Float.toString(f), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final double d, final int x, final int y) { return method_renderCentered.init(this, tessellator, Double.toString(d), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final int x, final int y) { return method_renderCentered.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerBase renderCentered(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final int x, final int y) {return method_renderCentered.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderCenteredDoubleImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, @Nullable final Object o, final double x, final double y) { return renderCenteredDouble(tessellator, String.valueOf(o), x, y); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final boolean b, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, Boolean.toString(b), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final int i, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, Integer.toString(i), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final long l, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, Long.toString(l), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final char c, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, String.valueOf(c), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final float f, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, Float.toString(f), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final double d, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, Double.toString(d), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final double x, final double y) { return method_renderCenteredDouble.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleBase renderCenteredDouble(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final double x, final double y) {return method_renderCenteredDouble.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderWidthConstrainedImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, @Nullable final Object o, final int x, final int y, final int maxWidth) { return renderWidthConstrained(tessellator, String.valueOf(o), x, y, maxWidth); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final boolean b, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, Boolean.toString(b), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final int i, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, Integer.toString(i), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final long l, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, Long.toString(l), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final char c, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, String.valueOf(c), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final float f, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, Float.toString(f), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final double d, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, Double.toString(d), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final int x, final int y, final int maxWidth) { return method_renderWidthConstrained.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderWidthConstrained(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final int x, final int y, final int maxWidth) {return method_renderWidthConstrained.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, maxWidth, Integer.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderWidthConstrainedDoubleImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, @Nullable final Object o, final double x, final double y, final double maxWidth) { return renderWidthConstrainedDouble(tessellator, String.valueOf(o), x, y, maxWidth); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final boolean b, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, Boolean.toString(b), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final int i, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, Integer.toString(i), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final long l, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, Long.toString(l), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final char c, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, String.valueOf(c), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final float f, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, Float.toString(f), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final double d, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, Double.toString(d), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final double x, final double y, final double maxWidth) { return method_renderWidthConstrainedDouble.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderWidthConstrainedDouble(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final double x, final double y, final double maxWidth) {return method_renderWidthConstrainedDouble.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, maxWidth, Double.MAX_VALUE, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderConstrainedImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, int x, int y, double z, boolean shadow, long baseConfig, int maxWidth, int maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, @Nullable final Object o, final int x, final int y, final int maxWidth, final int maxHeight) { return renderConstrained(tessellator, String.valueOf(o), x, y, maxWidth, maxHeight); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final boolean b, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, Boolean.toString(b), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final int i, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, Integer.toString(i), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final long l, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, Long.toString(l), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final char c, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, String.valueOf(c), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final float f, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, Float.toString(f), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final double d, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, Double.toString(d), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final int x, final int y, final int maxWidth, final int maxHeight) { return method_renderConstrained.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderIntegerConstrainedBase renderConstrained(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight) {return method_renderConstrained.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    abstract void renderConstrainedDoubleImpl(@NotNull Font font, @NotNull Tessellator tessellator, @NotNull CharSequence chars, double x, double y, double z, boolean shadow, long baseConfig, double maxWidth, double maxHeight, @NotNull Alignment alignment, double @Nullable [] xPosBuffer, double @Nullable [] yPosBuffer, long @Nullable [] configBuffer);
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, @Nullable final Object o, final double x, final double y, final double maxWidth, final double maxHeight) { return renderConstrainedDouble(tessellator, String.valueOf(o), x, y, maxWidth, maxHeight); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final boolean b, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, Boolean.toString(b), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final int i, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, Integer.toString(i), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final long l, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, Long.toString(l), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final char c, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, String.valueOf(c), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final float f, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, Float.toString(f), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final double d, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, Double.toString(d), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, final char @Nullable [] cArr, final double x, final double y, final double maxWidth, final double maxHeight) { return method_renderConstrainedDouble.init(this, tessellator, cArr == null ? NULL_STRING : new String(cArr), x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+    public final @NotNull RenderDoubleConstrainedBase renderConstrainedDouble(@NotNull final Tessellator tessellator, @Nullable final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight) {return method_renderConstrainedDouble.init(this, tessellator, chars == null ? NULL_STRING : chars, x, y, maxWidth, maxHeight, this.xPosBuffer, this.yPosBuffer, this.configBuffer); }
+
+    public final int getLastEndingX() {
+        return MathHelper.ceil(this.xPosBuffer[0]);
+    }
+    public final double getLastEndingXDouble() {
+        return this.xPosBuffer[0];
+    }
+    public final int getLastEndingY() {
+        return MathHelper.ceil(this.yPosBuffer[0]);
+    }
+    public final double getLastEndingYDouble() {
+        return this.yPosBuffer[0];
+    }
+    public final long getLastConfig() {
+        return this.configBuffer[0];
+    }
+
+    public abstract @NotNull List<String> splitCharsIntoLines(@NotNull Font font, @NotNull CharSequence chars, double maxWidth, @Nullable List<String> output);
+    public @NotNull List<String> splitCharsIntoLines(@NotNull final CharSequence chars, final double maxWidth, @Nullable final List<String> output) {
+        return splitCharsIntoLines(getFont(), chars, maxWidth, output);
+    }
+    public abstract @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull Font font, @NotNull List<String> lines, double maxWidth, @Nullable List<String> output);
+    public @NotNull List<String> splitLinesIntoConstrainedLines(@NotNull final List<String> lines, final double maxWidth, @Nullable final List<String> output) {
+        return splitLinesIntoConstrainedLines(getFont(), lines, maxWidth, output);
+    }
+    public abstract double heightOfConstrainedChars(@NotNull Font font, @NotNull CharSequence chars, double maxWidth);
+    public double heightOfConstrainedChars(@NotNull final CharSequence chars, final double maxWidth) {
+        return heightOfConstrainedChars(getFont(), chars, maxWidth);
+    }
+    public abstract double heightOfLines(@NotNull Font font, @NotNull List<String> lines, double maxWidth);
+    public double heightOfLines(@NotNull final List<String> lines, final double maxWidth) {
+        return heightOfLines(getFont(), lines, maxWidth);
+    }
+
+    public abstract @NotNull Font getFont();
+
+    public abstract double stringWidthDouble(@NotNull Font font, @NotNull CharSequence chars);
+    public int stringWidth(@NotNull final Font font, final @NotNull CharSequence chars) {
+        return MathHelper.ceil(stringWidthDouble(font, chars));
+    }
+    public double stringWidthDouble(final @NotNull CharSequence chars) {
+        return stringWidthDouble(getFont(), chars);
+    }
+    public int stringWidth(final @NotNull CharSequence chars) {
+        return stringWidth(getFont(), chars);
     }
 }
